var myerrorbuf = ''
var myerrordate = new Date();
var mounted = false;
var gamedir = 'valve';
var moduleCount = 0;
var mem = 150;
var mfs;
var zipSize;

// make BrowserFS to work on ES5 browsers
if (!ArrayBuffer['isView']) {
    ArrayBuffer.isView = function(a) {
        return a !== null && typeof(a) === "object" && a['buffer'] instanceof ArrayBuffer;
    };
}

try{mem = Math.round(window.location.hash.substring(1));}catch(e){};

var Module = {
    TOTAL_MEMORY: mem * 1024 * 1024,
    preRun: [],
    postRun: [], //TODO replace with windows 96 terminal
    print: function(t) {
        ctx.appContext.statusTerm.println(t);
    },
    printErr: function(t) {
        ctx.appContext.statusTerm.printError(t);
    },
    canvas: (function() {
        var canvas = document.getElementById('canvas');
        canvas.addEventListener("webglcontextlost", function(e) { ctx.appContext.statusTerm.println('WebGL context lost. You will need to reload the page.'); e.preventDefault(); }, false);
        return canvas;
    })(),
    setStatus: function(text) {
        if (!Module.setStatus.last) Module.setStatus.last = { time: Date.now(), text: '' };
        if (text === Module.setStatus.text) return;
        if(  new Date() - myerrordate > 3000 )
        {
            myerrordate = new Date();
            Module.print();
        }
        var m = text.match(/([^(]+)\((\d+(\.\d+)?)\/(\d+)\)/);
        if(m)
        {
            var progress = Math.round(parseInt(m[2])*100/parseInt(m[4]));
            ctx.appContext.statusTerm.println("ZIP load progress " + progress + "%");
        }
    },
    totalDependencies: 0,
    monitorRunDependencies: function(left) {
        this.totalDependencies = Math.max(this.totalDependencies, left);
        if(left)
            Module.setStatus('Preparing... (' + (this.totalDependencies-left) + '/' + this.totalDependencies + ')');
    }
};

window.onerror = function(event) {
    if(mounted)
        FS.syncfs(false, function(err){Module.print('Saving IDBFS: '+err);});
    if( (''+event).indexOf('SimulateInfiniteLoop') > 0 ) {
        // Exit application - close parent window
        ctx.close();
    }
};

function haltRun()
{
}

var savedRun;

Module.setStatus('Downloading...');
function startXash()
{
    setupFS();
    Module.arguments = [];
    Module.run = run = savedRun;
    fetchZIP(urls.uplink_zip, savedRun);
}

function mountZIP(data)
{
    var Buffer = BrowserFS.BFSRequire('buffer').Buffer;
    mfs.mount('/zip', new BrowserFS.FileSystem.ZipFS(Buffer.from(data)));
    FS.mount(new BrowserFS.EmscriptenFS(), {root:'/zip'}, '/rodir');
}

function fetchZIP(packageName, cb)
{
    var xhr = new XMLHttpRequest();
    xhr.open('GET', packageName, true);
    xhr.responseType = 'arraybuffer';

    xhr.onprogress = function(event) {
        var url = packageName;
        var size;
        if (event.total) size = event.total;
        else size = 30578171;
        if (event.loaded) {
            var total = size;
            var loaded = event.loaded;
            var num = 0;
            if (Module['setStatus']) Module['setStatus']('Downloading data... (' + loaded + '/' + total + ')');
        } else if (!Module.dataFileDownloads) {
            if (Module['setStatus']) Module['setStatus']('Downloading data...');
        }
    };

    xhr.onerror = function(event) {
        throw new Error("NetworkError");
    }
    
    xhr.onload = async function(event) {
        if (xhr.status == 200 || xhr.status == 304 || xhr.status == 206 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            mountZIP(xhr.response);
            cb();
        } else {
            throw new Error(xhr.statusText + " : " + xhr.responseURL);
        }
    };
    xhr.send(null);
}

function setupFS()
{
    FS.mkdir('/rodir');
    FS.mkdir('/xash');
    try
    { 
        mfs = new BrowserFS.FileSystem.MountableFileSystem();
        BrowserFS.initialize(mfs);
    }
    catch(e)
    {
        mfs = undefined;
        Module.print('Failed to initialize BrowserFS: '+e);
    }
    FS.chdir('/xash/');
}

function skipRun()
{
    savedRun = run;
    Module.run = haltRun;
    run = haltRun;

    Module.setStatus("Engine downloaded!");

    ENV.XASH3D_GAMEDIR = gamedir;
    ENV.XASH3D_RODIR = '/rodir'

    function loadModule(name)
    {
        var script = document.createElement('script');
        script.onload = function(){moduleCount++;if(moduleCount==3){Module.setStatus("Scripts downloaded!");
            try {
            } catch(e) {}
            startXash(ctx.appContext.argv);
        }};
        document.body.appendChild(script);
        script.src = name;
    }

    loadModule(urls.server_js);
    loadModule(urls.client_js);
    loadModule(urls.menu_js);
};

Module.preInit = [skipRun];
Module.websocket = [];
Module.websocket.url = 'wsproxy://mittorn.fwgs.ru:3000/'
ENV = [];